# -*- coding:sjis -*-
import glob
import Image, ImageDraw

png = ['monster0.png',
       'monster1.png',
       'monster2.png',
       'monster3.png',
       'monster4.png',
       'monster5.png',
       'monster6.png',
       'monster7.png',
       'monster8.png',
       'monster9.png',
       'monster10.png',
       'monster11.png',
       'monster12.png',
       'monster13.png',
       'monster14.png',
       'monster15.png',
       'monster16.png',
       'monster17.png',
       'monster18.png',
       'monster19.png',
       'monster20.png',
       'player0.png',
       'player1.png']


# spr
cnt = len(png)
spr = Image.new('RGB', (192/2, 256/2*cnt))

for i in range(cnt):
    im1 = Image.open(png[i])
    im1 = im1.crop((0, 0, 192, 256))
    im1 = im1.resize((192/2, 256/2))

    im2 = Image.new('RGB', im1.size, 0x000000)
    im2.paste(im1, mask=im1)

    spr.paste(im2, (0, 256/2*i))

spr.save("tmp_spr.bmp")


# bg
im1 = Image.open("tile.png").convert('RGB')
bg  = Image.new('RGB', (256, 32))

for i in range(7):
    im2 = im1.crop((i*32, 0, i*32+32, 32))
    bg.paste(im2, ((i+1)*32, 0))


bg.save("tmp_bg.bmp")

