#ifndef __DIR_H__
#define __DIR_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"

//---------------------------------------------------------------------------
#define DIR_MAX_TICK_CNT		15			//1JEg = 1VBLANK

enum {
	VEC_NONE = 0x00,	// Ȃ
	VEC_DOWN,			// ()
	VEC_UP,				// (w)
	VEC_LEFT,			// 
	VEC_RIGHT,			// E
	VEC_UP_LEFT,		// 
	VEC_UP_RIGHT,		// E
	VEC_DOWN_LEFT,		// 
	VEC_DOWN_RIGHT,		// E
};

//---------------------------------------------------------------------------
typedef struct {
	u16 pat;
	u16 vec;
} ST_DIR_CHR;


typedef struct {
	u16 tick;
	u16 seq;
} ST_DIR;


//---------------------------------------------------------------------------
EWRAM_CODE u16  DirChrGetVec(s16 mx, s16 my);
EWRAM_CODE u16  DirChrGetPat(ST_DIR_CHR* p);


//----
EWRAM_CODE void DirInit();
EWRAM_CODE void DirExec();


#ifdef __cplusplus
}
#endif
#endif
