#include "item.h"
#include "hero.h"


//---------------------------------------------------------------------------
// ACep[^dl

// Օi ITEMTYPE_USEITEM
// param[0]						param[1]		param[2]		param[3]
// USEITEM_CATEGORY_HPCURE					~gp		~gp	HP
// USEITEM_CATEGORY_POISONCURE	0:			~gp		~gp	ł̉
//								!0:t^^[ ~gp		~gp	ł̕t^
// USEITEM_CATEGORY_MAGIC		MP			U			etype	@
// USEITEM_CATEGORY_PROVE		~gp		~gp		~gp	Ӓ
// USEITEM_CATEGORY_FOOD					~gp		~gp	H
// USEITEM_CATEGORY_ARROW		U							~gp	
// USEITEM_CATEGORY_WARP		~gp		~gp		~gp	[_[v

//  ITEM_TYPE_WEAPON

// param[0]
// U

// h ITEM_TYPE_ARMOR
// param[0]
// h

// w ITEM_TYPE_RING
// param[0]														param[1]
//  0:U͑ 1:h͑ 2:MaxHP 3:MaxSP		l


const ST_ITEM ItemDB[] = {
	{ITEM_ID_USEITEM, "", "hN", {USEITEM_ID_HPCURE, 50, 0, 0}, TRUE }, // 0
	{ITEM_ID_USEITEM, "悭", "hN", {USEITEM_ID_HPCURE, 100, 0, 0}, TRUE }, // 1
	{ITEM_ID_USEITEM, "()", "hN", {USEITEM_ID_HPCURE, 50, 0, 0}, TRUE }, // 2
	{ITEM_ID_USEITEM, "()", "hN", {USEITEM_ID_HPCURE, HERO_MAX_HP_CNT, 0, 0}, TRUE }, // 3
	{ITEM_ID_USEITEM, "", "", {USEITEM_ID_HPCURE, -5, 0, 0}, TRUE }, // 4
	{ITEM_ID_WEAPON, "ʂ̏", "", {10, 0, 0, 0}, TRUE }, // 5
	{ITEM_ID_WEAPON, "悢", "", {20, 0, 0, 0}, TRUE }, // 6
	{ITEM_ID_WEAPON, "啪悢", "", {40, 0, 0, 0}, TRUE }, // 7
	{ITEM_ID_ARMOR, "ʂ̕", "", {10, 0, 0, 0}, TRUE }, // 8
	{ITEM_ID_ARMOR, "", "", {50, 0, 0, 0}, TRUE }, // 9
	{ITEM_ID_ARMOR, "ꂢȕ", "", {70, 0, 0, 0}, TRUE }, // 10
	{ITEM_ID_ARMOR, "Ŝ낢", "", {100, 0, 0, 0}, TRUE }, // 11
	{ITEM_ID_RING, "͂̎w", "w", {0, 5, 0, 0}, TRUE }, // 12 ATKup
	{ITEM_ID_RING, "̎w", "w", {1, 10, 0, 0}, TRUE }, // 13 DEFup
	{ITEM_ID_RING, "X^~iw", "w", {2, 25, 0, 0}, TRUE }, // 14 MaxHPup

	// Rœo
	{ITEM_ID_USEITEM, "Ŗ", "hN", {USEITEM_ID_POISONCURE, 5, 0, 0}, TRUE }, // 15
	{ITEM_ID_USEITEM, "Ŗ", "hN", {USEITEM_ID_POISONCURE, 0, 0, 0}, TRUE }, // 16
	{ITEM_ID_USEITEM, "΂̊", "", {USEITEM_ID_MAGIC, 5, 50, MAGIC_ID_ONCE}, TRUE }, // 17
	{ITEM_ID_USEITEM, "̊", "", {USEITEM_ID_MAGIC, 10, 100, MAGIC_ID_ONCE}, TRUE }, // 18
	{ITEM_ID_USEITEM, "ܔM̊", "", {USEITEM_ID_MAGIC, 20, 300, MAGIC_ID_ONCE}, TRUE }, // 19
	{ITEM_ID_RING, "_̎w", "w", {3, 20, 0, 0}, TRUE }, // 20
	{ITEM_ID_USEITEM, "ʂ̊", "", {USEITEM_ID_PROVE, 0, 0, 0}, TRUE }, // 21iACeӒ肷j
	{ITEM_ID_USEITEM, "p", "p", {USEITEM_ID_FOOD, 300, 0, 0}, TRUE }, // 22
	{ITEM_ID_USEITEM, "p", "p", {USEITEM_ID_FOOD, -10, 0, 0}, TRUE }, // 23
	{ITEM_ID_USEITEM, "؂̖", "", {USEITEM_ID_ARROW, 10, 5, 0}, TRUE }, // 24
	{ITEM_ID_USEITEM, "S̖", "", {USEITEM_ID_ARROW, 50, 5, 0}, TRUE }, // 25
	{ITEM_ID_USEITEM, "̖", "", {USEITEM_ID_ARROW, 150, 5, 0}, TRUE }, // 26
	{ITEM_ID_USEITEM, "ACLtC", "", {USEITEM_ID_WARP, 0, 0, 0}, TRUE }, // 27i[vj
	{ITEM_ID_USEITEM, "S̊", "", {USEITEM_ID_MAGIC, 5, 10, MAGIC_ID_ROOM}, TRUE },  // 28
	{ITEM_ID_USEITEM, "PU", "", {USEITEM_ID_MAGIC, 5, 10, MAGIC_ID_ONCE}, TRUE },  // 29
	{ITEM_ID_USEITEM, "ђʍU", "", {USEITEM_ID_MAGIC, 5, 80, MAGIC_ID_PENETRATE}, TRUE },  // 30
	{ITEM_ID_USEITEM, "ŃACe", "", {USEITEM_ID_HPCURE, -HERO_MAX_HP_CNT, 0, MAGIC_ID_PENETRATE}, TRUE },  // 31
};

//---------------------------------------------------------------------------
char ItemDispBuf[ITEM_MAX_NAME_CNT];		// \pobt@


//---------------------------------------------------------------------------
EWRAM_CODE void ItemInit(ST_ITEM* p)
{
	_Memset(p, 0x00, sizeof(ST_ITEM));
	p->id = ITEM_ID_NONE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ItemCopy(ST_ITEM* pDst, ST_ITEM* pSrc)
{
	_Memcpy(pDst, pSrc, sizeof(ST_ITEM));
}
//---------------------------------------------------------------------------
EWRAM_CODE char* ItemGetName(ST_ITEM* p)
{
	if(p->id == ITEM_ID_NONE)
	{
		_Strncpy(ItemDispBuf, "Ȃ", sizeof(ItemDispBuf));
		return ItemDispBuf;
	}

	if(ItemIsArrow(p) == TRUE)
	{
		// [10] ̂悤ɕ\܂
		_Sprintf(ItemDispBuf, "%s[%d]", (p->isUnidentified == TRUE) ? p->unName : p->name, p->param[2]);
		return ItemDispBuf;
	}

	return (p->isUnidentified == TRUE) ? p->unName : p->name;
}
//---------------------------------------------------------------------------
EWRAM_CODE bool ItemIsArrow(ST_ITEM* p)
{
	return (p->id == ITEM_ID_USEITEM && p->param[0] == USEITEM_ID_ARROW) ? TRUE : FALSE;
}
