#ifndef __GBFS_H__
#define __GBFS_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "lib/gba.h"

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//wb_i32oCgj
typedef struct {
	char sig[16];				// VOl` "PinEightGBFS" + 0x0d + 0x0a + 0x1a + 0x0a
	u32  size;					// A[JCȗ傫
	u16  dirOff;				// t@Cꗗ̃ItZbg(ROMI[̑)
	u16  fileCnt;				// t@C̓o^
	u8   noUse[8];				// 󂫗̈
} __PACKED ST_GBFS_HEADER;


//t@CXgi32oCgj
typedef struct {
	char fname[24];				// t@C
	u32  size;					// TCY
	u32  dataOff;				// t@C̃ItZbg(ROMI[̑)
} __PACKED ST_GBFS_LIST;


typedef struct {
	ST_GBFS_HEADER* pHeader;
	ST_GBFS_LIST*   pList;
	u32             size;
} ST_GBFS;

//---------------------------------------------------------------------------
EWRAM_CODE void  GbfsInit();

IWRAM_CODE void* GBFSGetPointer(char* fname);
IWRAM_CODE void* GBFSGetPointer2(u32 cnt);
IWRAM_CODE void* GBFSGetSafePointer(char* fname);
IWRAM_CODE void* GBFSGetSafePointer2(u32 cnt);

IWRAM_CODE u32   GbfsGetBodySize();
IWRAM_CODE u16   GbfsGetCnt();
IWRAM_CODE u32   GbfsGetSize();


#ifdef __cplusplus
}
#endif
#endif
