#ifndef __MOB_MAP_H__
#define __MOB_MAP_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"

//---------------------------------------------------------------------------

typedef struct {
	s16  cnt;
	bool isChk;
} ST_MOB_MAP_DATA ALIGN(4);

typedef struct {
	s16  cx;
	s16  cy;
	ST_MOB_MAP_DATA* pData;
} ST_MOB_MAP;


//---------------------------------------------------------------------------
EWRAM_CODE void MobMapCalloc();
EWRAM_CODE void MobMapFree();

IWRAM_CODE void MobMapMake();
EWRAM_CODE s16  MobMapGetVal(s16 sx, s16 sy);

EWRAM_CODE void MobMapDebug();


#ifdef __cplusplus
}
#endif
#endif
