#ifndef __SPR_H__
#define __SPR_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
typedef struct {
	u16 attr0;
	u16 attr1;
	u16 attr2;
	u16 attr3;
} ST_SPRITE;


typedef struct {
	u32 attr01;
	u32 attr23;
} ST_SPRITE32;


typedef struct {
	s16 cnt;
	s16 ofsX;
	s16 ofsY;
} ST_SPR;


//---------------------------------------------------------------------------
EWRAM_CODE void SprInit();
EWRAM_CODE void SprInitDat();
EWRAM_CODE void SprInitPal();
EWRAM_CODE void SprClean();


EWRAM_CODE void SprSetBuf(u16 idx, s32 x, s32 y);
EWRAM_CODE void SprSetVerti(s16 ofsY);
EWRAM_CODE void SprSetHoriz(s16 ofsX);





#ifdef __cplusplus
}
#endif
#endif
