#ifndef __DEBUG_H__
#define __DEBUG_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"

//---------------------------------------------------------------------------
#define DEBUG_FPS_CNT			60


//---------------------------------------------------------------------------
typedef struct {
	s16 fpsTimer;
	s16 fpsCnt;
	s16 gameTime;
	s16 gameFrame;
	s16 frameCnt;
	u16 fps;
	u16 delay;
} ST_DEBUG;


//---------------------------------------------------------------------------
EWRAM_CODE void DebugInit();
IWRAM_CODE void DebugExec();
IWRAM_CODE void DebugDraw();
IWRAM_CODE void DebugIntr();


#ifdef __cplusplus
}
#endif
#endif
