#ifndef __FADE_H__
#define __FADE_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "lib/gba.h"

//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
typedef struct {
	s16 min;
	s16 max;
	s16 wait;
} ST_FADE;


//---------------------------------------------------------------------------
EWRAM_CODE void FadeInit();
EWRAM_CODE void FadeSetCnt(s16 min, s16 max, s16 wait);
EWRAM_CODE void FadeIn();
EWRAM_CODE void FadeOut();


#ifdef __cplusplus
}
#endif
#endif
