#ifndef __ITEM_H__
#define __ITEM_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"

//---------------------------------------------------------------------------
#define ITEM_MAX_PARAM_CNT		4		// ACẽp[^
#define ITEM_MAX_NAME_CNT		20		// ACe̍ő吔
#define ITEM_MAX_UNNAME_CNT		10		// 
#define ITEM_MAX_ARROW_CNT		99		// ނ̖𑩂˂ő吔


enum {
	ITEM_ID_NONE = (0<<0),				// Ȃ
	ITEM_ID_USEITEM = (1<<0),			// Օi
	ITEM_ID_WEAPON = (1<<1),			// 
	ITEM_ID_ARMOR = (1<<2),				// h
	ITEM_ID_RING = (1<<3),				// w
	ITEM_ID_UNIDENTIFIED = (1<<4),		// ӒACê
};

enum {
	USEITEM_ID_HPCURE = 0x01,			// HP
	USEITEM_ID_MPCURE,					// MP
	USEITEM_ID_POISONCURE,				// 
	USEITEM_ID_MAGIC,					// U@()
	USEITEM_ID_PROVE,					// ACeӒ
	USEITEM_ID_FOOD,					// H
	USEITEM_ID_ARROW,					// 
	USEITEM_ID_WARP,					// [v
};

enum {
	MAGIC_ID_ONCE = 0x01,				// PI
	MAGIC_ID_PENETRATE,					// ђ
	MAGIC_ID_ROOM,						// S
};

//---------------------------------------------------------------------------
typedef struct {
	u8   id;							// ACe
	char name[ITEM_MAX_NAME_CNT];		// O
	char unName[ITEM_MAX_UNNAME_CNT];	// Ӓ莞̖O

	s16  param[ITEM_MAX_PARAM_CNT];		// p[^

	bool isUnidentified;				// ӒȂTRUE
} ST_ITEM;


//---------------------------------------------------------------------------
EWRAM_CODE void  ItemInit(ST_ITEM* p);
EWRAM_CODE void  ItemCopy(ST_ITEM* pDst, ST_ITEM* pSrc);
EWRAM_CODE char* ItemGetName(ST_ITEM* p);
EWRAM_CODE bool  ItemIsArrow(ST_ITEM* p);


#ifdef __cplusplus
}
#endif
#endif
