#include "mob.h"
#include "mobmap.h"
#include "hero.h"
#include "dun.h"
#include "game.h"
#include "dir.h"
#include "spr.h"


//---------------------------------------------------------------------------
static const ST_MOB_DB MobDB[] = {
	// 񕜖hbv																	ۯ߱
	// O			oKw	AI	ol		U	h	s	̗ 摜ID	ID	 Ӓ藦
	{ "fXl[N",	1, 10,		1,	 3,		20,		1,		0,		30,		8,	0,		0,	 98, 0 },
	{ "fXl[N",	11, 20,		2,  65,		20,	   30,	   60,		12,	   70,	5,		1,	 98, 0 },
	{ "fXl[N",	21, 30,		2, 500,		20,	   70,	  180,		10,	  300,	6,		1,	 98, 0 },
	{ "fXl[N",	21, 30,		2, 500,		20,	   70,	  180,		10,	  300,	6,		1,	 98, 0 },
	{ "m[",		2, 13,		2,	 8,		30,	   10,	   18,		28,		20,	1,		2,	 90, 3 },
	{ "m[",		14, 23,		2,	80,		30,	   52,	   18,		22,		50,	9,		2,	 90, 3 },
	{ "m[",		24, 33,		2, 800,		30,	   80,	  160,		18,	   400,	10,		2,	 90, 3 },
	{ "m[",		24, 33,		2, 800,		30,	   80,	  160,		18,	   400,	10,		2,	 90, 3 },
	{ "m[",		24, 33,		2, 800,		30,	   80,	  160,		18,	   400,	10,		2,	 90, 3 },
	{ "m[",		24, 33,		2, 800,		30,	   80,	  160,		18,	   400,	10,		2,	 90, 3 },
	{ "Xsbc",	5, 15,		3,	16,		60,	   26,	   55,		15,		50,	2,		2,	 80, 6 },
	{ "Xsbc",	16, 25,		3, 300,		40,	   49,	   80,		14,	   300,	13,		2,	 80, 6 },
	{ "hS",	22, 31,		3, 810,		40,	   75,	  180,		15,	   500,	3,		2,	100, 15 },
	{ "hS",	22, 31,		3, 810,		40,	   75,	  180,		15,	   500,	3,		2,	100, 15 },
	{ "hS",	22, 31,		3, 810,		40,	   75,	  180,		15,	   500,	3,		2,	100, 15 },
	{ "hS",	22, 31,		3, 810,		40,	   75,	  180,		15,	   500,	3,		2,	100, 15 },

	// ŁEHEӒ
	// O			oKw	AI	ol		U	h	s	̗ 摜ID	ID	 Ӓ藦
	{ "fXl[N",	1, 10,		1,	 3,		20,		1,		0,		30,		8,	0,		16,	 70, 0 },
	{ "fXl[N",	1, 10,		1,	 3,		20,		1,		0,		30,		8,	0,		22,	 80, 0 },
	{ "fXl[N",	11, 20,		2,  65,		20,	   30,	   60,		12,	   70,	5,		16,	 70, 0 },
	{ "fXl[N",	11, 20,		2,  65,		20,	   30,	   60,		12,	   70,	5,		22,	 80, 0 },
	{ "fXl[N",	21, 30,		2, 200,		20,	   10,	   10,		10,	   32,	6,		16,	 70, 0 },
	{ "fXl[N",	21, 30,		2, 200,		20,	   10,	   10,		10,	   32,	6,		22,	 80, 0 },
	{ "m[",		3, 13,		2,	 8,		30,	   10,	   18,		28,		20,	1,		16,	 40, 3 },
	{ "m[",		3, 13,		2,	 8,		30,	   10,	   18,		28,		20,	1,		22,	 80, 3 },
	{ "m[",		14, 23,		2, 100,		30,	   35,	   75,		22,	   120,	9,		16,	 40, 3 },
	{ "m[",		14, 23,		2, 100,		30,	   35,	   75,		22,	   120,	9,		24,	 90, 3 },
	{ "Xsbc",	5, 15,		3,	16,		40,	   26,	   55,		15,		50,	2,		16,	 40, 6 },
	{ "Xsbc",	5, 15,		3,	16,		40,	   26,	   55,		15,		50,	2,		22,	 80, 6 },
	{ "Xsbc",	16, 25,		3, 300,		40,	   49,	   80,		14,	   300,	13,		16,	 40, 6 },

	// Ӓ
	// O			oKw	AI	ol		U	h	s	̗ 摜ID	ID	 Ӓ藦
	{ "fXl[N",	1, 10,		1,	 3,		20,		1,		0,		30,		8,	0,		21,	 40, 0 },
	{ "fXl[N",	11, 20,		2,  65,		20,	   30,	   60,		12,	   70,	5,		21,	 40, 0 },
	{ "fXl[N",	21, 30,		2, 200,		20,	   10,	   10,		10,	   32,	6,		21,	 40, 0 },

 	// 
	// O			oKw	AI	ol		U	h	s	̗ 摜ID	ID	 Ӓ藦
	{ "m[",		 3, 13,		2,	 8,		30,	   10,	   18,		28,		20,	1,		24,	 90, 0 },
	{ "m[",		14, 23,		2, 100,		30,	   35,	   75,		22,	   120,	9,		25,	 90, 3 },
	{ "m[",		24, 33,		2, 800,		30,	   30,	   25,		18,	   120,	10,		26,	 90, 3 },

	// 
	// O			oKw	AI	ol		U	h	s	̗ 摜ID	ID	 Ӓ藦
	{ "Xsbc",	5, 15,		3,	16,		60,	   26,	   55,		15,		50,	2,		17,	 80, 0 },
	{ "Xsbc",	16, 25,		3, 300,		40,	   49,	   80,		14,	   300,	13,		17,	 80, 6 },

	// w
	{ "fXl[N",	16, 19,		3,  150,	20,	   30,	   80,		10,	   250,	5,		12,	 5, 50 },
	{ "fXl[N",	21, 30,		2,  500,	20,	   70,	  180,		10,	  300,	6,		13,	 10, 0 },
};
//---------------------------------------------------------------------------
ST_MOB Mob;


//---------------------------------------------------------------------------
EWRAM_CODE void MobInit()
{
	_Memset(&Mob, 0x00, sizeof(ST_MOB));
}
//---------------------------------------------------------------------------
EWRAM_CODE bool MobLoad()
{
	if(SramIsStr("MOBS") == FALSE)
	{
		return FALSE;
	}

	u16 size = SramRead16();
	u16 ver  = SramRead16();

	SramReadCopy((u8*)&Mob, size);

	return TRUE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobSave()
{
	u16 size = sizeof(ST_MOB);
	u16 ver  = 100;

	SramWriteCopy((u8*)"MOBS", 4);
	SramWrite16(size);
	SramWrite16(ver);

	SramWriteCopy((u8*)&Mob, size);
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobTurn()
{
	s16 tick = HeroGetSpeed();
	s16 i;

	// AI⏕f[^쐬܂
	MobMapCalloc();

	for(i=0; i<Mob.cnt; i++)
	{
		ST_MOB_CHR* pMob = MobGetChr2(i);

		pMob->tickCnt -= tick;

		if(pMob->tickCnt <= 0)
		{
			pMob->tickCnt += tick;
			MobMove(pMob);
		}
	}

	//
//	MobMapDebug();
	MobMapFree();
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobDraw()
{
	s16 sx = HeroGetX() - 3;
	s16 sy = HeroGetY() - 2;
	s16 ex = sx + 8;
	s16 ey = sy + 5;
	s16 i;

	for(i=0; i<Mob.cnt; i++)
	{
		ST_MOB_CHR* pMob = MobGetChr2(i);

		if(pMob->x < sx && pMob->x >= ex)
		{
			continue;
		}

		if(pMob->y < sy && pMob->y >= ey)
		{
			continue;
		}

		u16 pat = DirChrGetPat(&pMob->dir);
		SprSetBuf(pat, 32*(pMob->x - sx)+16, 32*(pMob->y - sy)+16);
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobSort()
{
	s16 i, j;

	// TODO f[^\ƃ[`̉

	for(i=0; i<MAX_MOB_CNT-1; i++)
	{
		ST_MOB_CHR* pMob1 = MobGetChr2(i);

		if(pMob1->hp != 0)
		{
			continue;
		}

		for(j=i+1; j<MAX_MOB_CNT; j++)
		{
			ST_MOB_CHR* pMob2 = MobGetChr2(j);

			if(pMob2->hp != 0)
			{
				MobCopy(pMob1, pMob2);
				pMob2->hp = 0;
				break;
			}
		}
	}


	Mob.cnt = 0;
	for(i=0; i<MAX_MOB_CNT; i++)
	{
		if(Mob.chr[i].hp != 0)
		{
			Mob.cnt++;
		}
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobCopy(ST_MOB_CHR* pDst, ST_MOB_CHR* pSrc)
{
	_Memcpy(pDst, pSrc, sizeof(ST_MOB_CHR));
}
//---------------------------------------------------------------------------
EWRAM_CODE ST_MOB_CHR* MobMake()
{
	if(Mob.cnt < MAX_MOB_CNT)
	{
		Mob.cnt++;
	}

	return &Mob.chr[Mob.cnt-1];
}
//---------------------------------------------------------------------------
EWRAM_CODE ST_MOB_CHR* MobMakeRnd(s16 x, s16 y, s16 floorCnt)
{
	// KX^[ɓ܂ň܂
	const ST_MOB_DB* pMobDB;

	for(;;)
	{
		s16 idx = _Rand(sizeof(MobDB) / sizeof(*MobDB));
		pMobDB = &MobDB[idx];

		if(pMobDB->firstFloorCnt <= floorCnt && pMobDB->lastFloorCnt >= floorCnt)
		{
			break;
		}
	}

	// X^[o^܂
	ST_MOB_CHR* pMob = MobMake();

	_Strncpy(pMob->name, (char*)pMobDB->name, MAX_MOB_NAME_CNT);
	pMob->ai               = pMobDB->ai;
	pMob->exp              = pMobDB->exp;
	pMob->agi              = pMobDB->agi;
	pMob->atk              = pMobDB->atk;
	pMob->def              = pMobDB->def;
	pMob->speed            = pMobDB->speed;
	pMob->hp               = pMobDB->hp;
	pMob->dir.pat          = pMobDB->graphic;		// graphic
	pMob->dropItemID       = pMobDB->dropItemID;
	pMob->dropPercent      = pMobDB->dropPercent;
	pMob->dropUnidentified = pMobDB->dropUnidentified;

	pMob->isUnidentified   = ((s16)_Rand(100) < pMob->dropUnidentified) ? TRUE : FALSE;
	pMob->x                = x;
	pMob->y                = y;
	pMob->tickCnt          = pMob->speed;
	pMob->maxHp            = pMob->maxHp;
	pMob->dir.vec          = VEC_DOWN;

	return pMob;
}
//---------------------------------------------------------------------------
EWRAM_CODE ST_MOB_CHR* MobGetChr(s16 x, s16 y)
{
	s16 i;

	for(i=0; i<Mob.cnt; i++)
	{
		if(Mob.chr[i].x == x && Mob.chr[i].y == y)
		{
			return &Mob.chr[i];
		}
	}

	return NULL;
}
//---------------------------------------------------------------------------
EWRAM_CODE ST_MOB_CHR* MobGetChr2(s16 num)
{
	return &Mob.chr[num];
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 MobGetCnt()
{
	return Mob.cnt;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 MobGetAtk(ST_MOB_CHR* pMob)
{
	return pMob->atk;
}
//---------------------------------------------------------------------------
EWRAM_CODE s16 MobAddDmg(ST_MOB_CHR* pMob, s16 dmg)
{
	if(dmg > 0)
	{
		pMob->hp -= dmg;

		if(pMob->hp <= 0)
		{
			pMob->hp = 0;
		}
	}

	return dmg;
}
//---------------------------------------------------------------------------
EWRAM_CODE bool MobIsMaxCnt()
{
	return (Mob.cnt >= MAX_MOB_CNT) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE bool MobIsDead(ST_MOB_CHR* pMob)
{
	return (pMob->hp <= 0) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobMove(ST_MOB_CHR* pMob)
{
	switch(pMob->ai)
	{
	case 1:
		MobMoveChr1(pMob);
		break;

	case 2:
		MobMoveChr1(pMob);
		break;

	case 3:
		MobMoveChr1(pMob);
		break;

	default:
		SystemError("[Err] MobMove pMob->ai");
		break;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobMoveChr1(ST_MOB_CHR* pMob)
{
	// _ɓ܂
	s16 x = _Rand(3) - 1;
	s16 y = _Rand(3) - 1;

	MobMoveAct(pMob, pMob->x + x, pMob->y + y);
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobMoveChr2(ST_MOB_CHR* pMob)
{
	s16 val = MobMapGetVal(pMob->x, pMob->y);

	// 100ȉ̏ꍇA_ړɂ܂
	if(val <= 0 || val > 100)
	{
		MobMoveChr1(pMob);
		return;
	}

	// vC[ǂ܂
	s16 rX = pMob->x;
	s16 rY = pMob->y;
	MobMoveTest(&rX, &rY, FALSE);

	if(pMob->x == rX && pMob->y == rY)
	{
		MobMoveChr1(pMob);
		return;
	}

	MobMoveAct(pMob, rX, rY);
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobMoveChr3(ST_MOB_CHR* pMob)
{
	// ̗͂P/Sȏ゠΁Aǂ܂
	if(pMob->hp*4 >= pMob->maxHp)
	{
		MobMoveChr2(pMob);
		return;
	}

	// vC[瓦܂
	s16 rX = pMob->x;
	s16 rY = pMob->y;
	MobMoveTest(&rX, &rY, TRUE);

	if(pMob->x == rX && pMob->y == rY)
	{
		MobMoveChr1(pMob);
		return;
	}

	MobMoveAct(pMob, rX, rY);
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobMoveChr4(ST_MOB_CHR* pMob)
{
	MobMoveChr3(pMob);
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobMoveAct(ST_MOB_CHR* pMob, s16 mx, s16 my)
{
	ST_TILE* pTile = DunGetTile(mx, my);

	if(pTile == NULL)
	{
		return;
	}
	else if(pTile->isWall == TRUE)
	{
		return;
	}

	// vC[̃`FbN
	s16 hx = HeroGetX();
	s16 hy = HeroGetY();

	if(hx == mx && hy == my)
	{
		GameActMobAtk(pMob);
		return;
	}

	// ̃X^[̃`FbN
	if(MobGetChr(mx, my) != NULL)
	{
		return;
	}

	pMob->dir.vec = DirChrGetVec(mx - pMob->x, my - pMob->y);
	pMob->x       = mx;
	pMob->y       = my;
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobMoveTest(s16* px, s16* py, bool isToBig)
{
	s16 nx  = *px;
	s16 ny  = *py;
	s16 val = MobMapGetVal(nx, ny);
	s16 val2;

	// 
	val2 = MobMapGetVal(nx, ny-1);
	if(MobMoveIsComp(val, val2, isToBig) == TRUE)
	{
		nx  = nx;
		ny  = ny-1;
		val = val2;
	}

	// 
	val2 = MobMapGetVal(nx-1, ny);
	if(MobMoveIsComp(val, val2, isToBig) == TRUE)
	{
		nx  = nx-1;
		ny  = ny;
		val = val2;
	}

	// E
	val2 = MobMapGetVal(nx+1, ny);
	if(MobMoveIsComp(val, val2, isToBig) == TRUE)
	{
		nx  = nx+1;
		ny  = ny;
		val = val2;
	}

	// 
	val2 = MobMapGetVal(nx, ny+1);
	if(MobMoveIsComp(val, val2, isToBig) == TRUE)
	{
		nx  = nx;
		ny  = ny+1;
		val = val2;
	}

	// 
	val2 = MobMapGetVal(nx-1, ny-1);
	if(MobMoveIsComp(val, val2, isToBig) == TRUE)
	{
		nx  = nx-1;
		ny  = ny-1;
		val = val2;
	}

	// E
	val2 = MobMapGetVal(nx+1, ny-1);
	if(MobMoveIsComp(val, val2, isToBig) == TRUE)
	{
		nx  = nx+1;
		ny  = ny-1;
		val = val2;
	}

	// 
	val2 = MobMapGetVal(nx-1, ny+1);
	if(MobMoveIsComp(val, val2, isToBig) == TRUE)
	{
		nx  = nx-1;
		ny  = ny+1;
		val = val2;
	}

	// E
	val2 = MobMapGetVal(nx+1, ny+1);
	if(MobMoveIsComp(val, val2, isToBig) == TRUE)
	{
		nx  = nx+1;
		ny  = ny+1;
		val = val2;
	}

	*px = nx;
	*py = ny;
}
//---------------------------------------------------------------------------
// toBig  true ȂAa < b ł true Ԃ
// toBig  falseȂAa > b ł true Ԃ
// a  b  0 Ȃ false Ԃ
EWRAM_CODE bool MobMoveIsComp(s16 a, s16 b, bool toBig)
{
	if(a==0 || b==0)
	{
		return FALSE;
	}

	if(toBig == TRUE)
	{
		if(a < b)
		{
			return TRUE;
		}
	}
	else
	{
		if(a > b)
		{
			return TRUE;
		}
	}

	return FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void MobDebug()
{
	TRACEOUT("--MobDebug Start--\n");
	TRACEOUT("Mob.cnt=%d\n", Mob.cnt);

	s16 i;

	for(i=0; i<Mob.cnt; i++)
	{
		ST_MOB_CHR* p = &Mob.chr[i];

		TRACEOUT("----");
		TRACEOUT("No.%d\n",   i);
		TRACEOUT("name=%s\n", p->name);
		TRACEOUT("x=%d\n",    p->x);
		TRACEOUT("y=%d\n",    p->y);
		TRACEOUT("hp=%d\n",    p->hp);
//		TRACEOUT("ai=%d\n",   p->ai);
//		TRACEOUT("agi=%d\n",  p->agi);
//		TRACEOUT("atk=%d\n",  p->atk);
//		TRACEOUT("def=%d\n",  p->def);

		TRACEOUT("dropUnidentified=%d\n", p->dropUnidentified);
		TRACEOUT("isUnidentified=%s\n", (p->isUnidentified == TRUE) ? "TRUE" : "FALSE");
	}

	TRACEOUT("--MobDebug End--\n");
}

