#ifndef __MSG_H__
#define __MSG_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"

//---------------------------------------------------------------------------
#define MSG_MAX_CNT			10
#define MSG_MAX_LEN			(60+1)

enum {
	MSG_ID_INFO = 0x00,		// 
	MSG_ID_ATTACK,			// _[Wn
	MSG_ID_SELECT,			// I
	MSG_ID_NEGATIVE,		// lKeBuȏ
};

//---------------------------------------------------------------------------
typedef struct {
	u16  id;
	char str[MSG_MAX_LEN];
} ST_MSG_DATA;


typedef struct {
	bool isDraw;
	s16  cnt;
	ST_MSG_DATA data[MSG_MAX_CNT];
} ST_MSG;


//----
typedef struct {
	bool isDraw;
	char str[MSG_MAX_LEN];
} ST_SEL;

//---------------------------------------------------------------------------
EWRAM_CODE void MsgInit();
EWRAM_CODE void MsgAdd(u16 id, char* format, ...);
EWRAM_CODE void MsgDraw();
EWRAM_CODE void MsgHide();


//----
EWRAM_CODE void SelInit();
EWRAM_CODE void SelAdd(char* format, ...);
EWRAM_CODE void SelDraw();
EWRAM_CODE void SelHide();


#ifdef __cplusplus
}
#endif
#endif
