#ifndef __SPR_ANIME_H__
#define __SPR_ANIME_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"

//---------------------------------------------------------------------------
#define INT2FIX(A)					((A)<<7)
#define FIX2INT(A)					((A)>>7)


//---------------------------------------------------------------------------
typedef struct {
	u16 idx;	// 
	s16 cx;		// center x
	s16 cy;		// center y
	u16 flip;	// default flip
} ST_SPR_PAT;


typedef struct {
	u16 regCnt;
	ST_SPR_PAT p[];
} ST_SPR_ANIME;


//---------------------------------------------------------------------------


#ifdef __cplusplus
}
#endif
#endif
